// market.h: interface for the Market class.
//
//////////////////////////////////////////////////////////////////////

#if !defined( MARKET_H_INCLUDED)
#define MARKET_H_INCLUDED

// For stupid M$ compiler
#pragma warning ( disable : 4786 )

#include <string>
#include <map>

class Market {

	public:
		typedef std::string Symbol;
		Market() {}

		// Note: this very simple class has no destructor, assignment or copy c'tor
		// because the default ones are OK (I hope!)
		bool getPrice( const Symbol& s, unsigned int * p ) const {
			if ( m_prices.find( s ) == m_prices.end() ) {
				return false;
			}
			
			// Can't use [] operator here because we are a const fn
			*p = ( m_prices.find( s ))->second;
			return true;
		}
  
		void setPrice( const Symbol& s, unsigned int p ) { m_prices[s] = p; }

	private:
		std::map<Symbol, unsigned int> m_prices;

};

#endif // !defined(MARKET_H_INCLUDED)