//
// intstack.h: header for the Inststack class.
//

#ifndef INTSTACK_H
#define INTSTACK_H

// typedef long unsigned int size_t;      as found in <iostream>


class IntStack {
	
	friend void printStack(IntStack* p);
	
	public:
		IntStack(size_t n = 2);					// constructor
		~IntStack();							// destructor
		void reset();							// reset the stack
		void push(int n);						// push int onto stack
		void push(int a[], size_t array_size);  // push array onto stack
		int  pop();								// pop  int off the stack
		void pop(int a[], size_t n);			// pop n inits into a[]
		void doubleCapacity();					// double the capacity of the stack
		bool is_full();							// get if stack if full
		bool is_empty();						// get if stack is empty
		size_t size();							// get the stack size
		size_t capacity();						// get the capacity of the stack
		
	private:
	
		size_t max_size;						// the capacity of stack
		int*   stack;							// points to the stack of ints
		size_t top_of_stack;					// next free item in stack
		

};
#endif // INTSTACK_H
