#ifndef _TEXT_UTIL
#define _TEXT_UTIL

#include <vector>
#include <string>
#include <utility>
#include <map>

typedef std::vector< std::pair<size_t, size_t> > IntPairVector;
typedef std::vector< std::pair<std::string, size_t> > StringIntVector;

class TextUtil
{
public:
	TextUtil (const std::string& filename);
	IntPairVector wordLengths() const;
	size_t wordCount (const std::string& word) const;
	StringIntVector topNWords (size_t n) const;
private:
	typedef std::map <std::string, size_t> WordCountMap;
	IntPairVector m_wordLengths;
	WordCountMap m_wordCounts;
};

#endif
