// main.cpp : Defines the entry point for the program.
//

#include "market.h"
#include "account.h"
// If your solution uses it's own header file, include it here
// Otherwise, just comment the next line out
//#include "asgn5soln.h"
#include <iostream>
#include <vector>

using std::cerr;
using std::cout;
using std::cin;
using std::endl;
using std::string;
using std::vector;

void testAllAccountsWithExceptions();
void testAccountWithoutExceptions();
void testGoldAccountWithoutExceptions();
void testPlatinumAccountWithoutExceptions();

void dieAfterReturn()
{
  cerr << "Press return to exit...";
  cin.sync();
  cin.get();
  exit( 0 );
}

int main(int argc, char* argv[])
{
  std::cout << "Hello trader!\n";

  testAccountWithoutExceptions();
  cout << "=================================================================" << endl;
  testGoldAccountWithoutExceptions();
  cout << "=================================================================" << endl;
  testPlatinumAccountWithoutExceptions();
  cout << "=================================================================" << endl;

  // Uncomment this to activate section 2 of the driver:
  testAllAccountsWithExceptions();

  // Under Windows, you might want to uncomment this when running under 
  // the debugger to keep the window from disappearing on you when the 
  // program finishes.
  
  dieAfterReturn();
  return 0;
}


void testAccountWithoutExceptions()
{
  Market NASDAQ;

  NASDAQ.setPrice( "MS", 14 );
  NASDAQ.setPrice( "Cisco", 110 );
  NASDAQ.setPrice( "Bubble.com", 223 );
  NASDAQ.setPrice( "Biota", 146 );

  Account acct1( NASDAQ );
  cout << "Account 1: " << endl << acct1 << endl;
  cout << "acct1.deposit( 100000 ); returns " 
       << acct1.deposit( 100000 ) << endl;
  cout << acct1 << endl;
  

  cout << "acct1.buy( \"Biota\", 100 ); returns " 
       << acct1.buy( "Biota", 100 ) << endl;
  cout << "acct1.buy( \"Cisco\", 200 ); returns " 
       << acct1.buy( "Cisco", 200 ) << endl;
  cout << "acct1.buy( \"Bubble.com\", 50 ); returns " 
       << acct1.buy( "Bubble.com", 50 ) << endl;
  
  cout << "acct1.withdraw( 100 ); returns " 
       << acct1.withdraw( 100 ) << endl;
  cout << "acct1.withdraw( 20000 ); returns " 
       << acct1.withdraw( 20000 ) << endl;
  // Expect failure here
  cout << "acct1.withdraw( 1000000 ); returns " 
       << acct1.withdraw( 1000000 ) << endl;
  
  cout << acct1 << endl;

  NASDAQ.setPrice( "MS", 12 );
  NASDAQ.setPrice( "Cisco", 120 );
  NASDAQ.setPrice( "Bubble.com", 323 );
  NASDAQ.setPrice( "Biota", 158 );

  cout << "acct1.sell( \"Biota\", 100 ); returns " 
       << acct1.sell( "Biota", 100 ) << endl;
  cout << "acct1.sell( \"Cisco\", 100 ); returns " 
       << acct1.sell( "Cisco", 100 ) << endl;
  cout << acct1 << endl;
  
  // Expect false here
  cout << "acct1.sell( \"Biota\", 100 ); returns " 
       << acct1.sell( "Biota", 100 ) << endl; 
  cout << "acct1.sell( \"Cisco\", 100 ); returns " 
       << acct1.sell( "Cisco", 100 ) << endl;
  cout << "acct1.sell( \"Bubble.com\", 50 ); returns " 
       << acct1.sell( "Bubble.com", 50 ) << endl;

  cout << acct1 << endl;


}


void testGoldAccountWithoutExceptions()
{
  Market NASDAQ;

  NASDAQ.setPrice( "MS", 14 );
  NASDAQ.setPrice( "Cisco", 110 );
  NASDAQ.setPrice( "Bubble.com", 223 );
  NASDAQ.setPrice( "Biota", 146 );

  GoldAccount goldAcct1( NASDAQ );
  cout << "Account 1: " << endl << goldAcct1 << endl;
  cout << "goldAcct1.deposit( 100000 ); returns " 
       << goldAcct1.deposit( 100000 ) << endl;
  cout << goldAcct1 << endl;
  goldAcct1.processInterest();
  

  cout << "goldAcct1.buy( \"Biota\", 100 ); returns " 
       << goldAcct1.buy( "Biota", 100 ) << endl;
  cout << "goldAcct1.buy( \"Cisco\", 200 ); returns " 
       << goldAcct1.buy( "Cisco", 200 ) << endl;
  cout << "goldAcct1.buy( \"Bubble.com\", 50 ); returns " 
       << goldAcct1.buy( "Bubble.com", 50 ) << endl;
  
  cout << "goldAcct1.withdraw( 100 ); returns " 
       << goldAcct1.withdraw( 100 ) << endl;
  cout << "goldAcct1.withdraw( 20000 ); returns " 
       << goldAcct1.withdraw( 20000 ) << endl;
  // Expect failure here
  cout << "goldAcct1.withdraw( 1000000 ); returns " 
       << goldAcct1.withdraw( 1000000 ) << endl;
  
  cout << goldAcct1 << endl;

  NASDAQ.setPrice( "MS", 12 );
  NASDAQ.setPrice( "Cisco", 120 );
  NASDAQ.setPrice( "Bubble.com", 323 );
  NASDAQ.setPrice( "Biota", 158 );

  cout << "goldAcct1.sell( \"Biota\", 100 ); returns " 
       << goldAcct1.sell( "Biota", 100 ) << endl;
  cout << "goldAcct1.sell( \"Cisco\", 100 ); returns " 
       << goldAcct1.sell( "Cisco", 100 ) << endl;
  cout << goldAcct1 << endl;
  goldAcct1.processInterest();
  
  // Expect false here
  cout << "goldAcct1.sell( \"Biota\", 100 ); returns " 
       << goldAcct1.sell( "Biota", 100 ) << endl; 
  cout << "goldAcct1.sell( \"Cisco\", 100 ); returns " 
       << goldAcct1.sell( "Cisco", 100 ) << endl;
  cout << "goldAcct1.sell( \"Bubble.com\", 50 ); returns " 
       << goldAcct1.sell( "Bubble.com", 50 ) << endl;

  cout << goldAcct1 << endl;


}


void testPlatinumAccountWithoutExceptions()
{
  Market NASDAQ;

  NASDAQ.setPrice( "MS", 14 );
  NASDAQ.setPrice( "Cisco", 110 );
  NASDAQ.setPrice( "Bubble.com", 223 );
  NASDAQ.setPrice( "Biota", 146 );

  PlatinumAccount platAcct1( NASDAQ );
  cout << "Account 1: " << endl << platAcct1 << endl;
  cout << "platAcct1.deposit( 100000 ); returns " 
       << platAcct1.deposit( 100000 ) << endl;
  cout << platAcct1 << endl;
  platAcct1.processInterest();
  

  cout << "platAcct1.buy( \"Biota\", 100 ); returns " 
       << platAcct1.buy( "Biota", 100 ) << endl;
  cout << "platAcct1.buy( \"Cisco\", 200 ); returns " 
       << platAcct1.buy( "Cisco", 200 ) << endl;
  cout << "platAcct1.buy( \"Bubble.com\", 50 ); returns " 
       << platAcct1.buy( "Bubble.com", 50 ) << endl;
  
  cout << "platAcct1.withdraw( 100 ); returns " 
       << platAcct1.withdraw( 100 ) << endl;
  cout << "platAcct1.withdraw( 20000 ); returns " 
       << platAcct1.withdraw( 20000 ) << endl;
  // Expect failure here
  cout << "platAcct1.withdraw( 1000000 ); returns " 
       << platAcct1.withdraw( 1000000 ) << endl;
  
  cout << platAcct1 << endl;

  NASDAQ.setPrice( "MS", 12 );
  NASDAQ.setPrice( "Cisco", 120 );
  NASDAQ.setPrice( "Bubble.com", 323 );
  NASDAQ.setPrice( "Biota", 158 );

  cout << "platAcct1.sell( \"Biota\", 100 ); returns " 
       << platAcct1.sell( "Biota", 100 ) << endl;
  cout << "platAcct1.sell( \"Cisco\", 100 ); returns " 
       << platAcct1.sell( "Cisco", 100 ) << endl;
  cout << platAcct1 << endl;
  platAcct1.processInterest();
  
  // Expect false here
  cout << "platAcct1.sell( \"Biota\", 100 ); returns " 
       << platAcct1.sell( "Biota", 100 ) << endl; 
  cout << "platAcct1.sell( \"Cisco\", 100 ); returns " 
       << platAcct1.sell( "Cisco", 100 ) << endl;
  cout << "platAcct1.sell( \"Bubble.com\", 50 ); returns " 
       << platAcct1.sell( "Bubble.com", 50 ) << endl;

  cout << platAcct1 << endl;


}

typedef std::vector< Account_base* >::iterator AcctIter;

void testAllAccountsWithExceptions()
{
  Market NASDAQ;
  
  NASDAQ.setPrice( "MS", 14 );
  NASDAQ.setPrice( "Cisco", 110 );
  NASDAQ.setPrice( "Bubble.com", 223 );
  NASDAQ.setPrice( "Biota", 146 );
  
  vector < Account_base* > accts; 
  Account_base* pAcct = new Account( NASDAQ );
  accts.push_back ( pAcct );

  pAcct = new GoldAccount( NASDAQ );
  accts.push_back ( pAcct );

  pAcct = new PlatinumAccount( NASDAQ );
  accts.push_back ( pAcct );


  int i;
  for ( i = 0; i < accts.size(); i++ )
  {
	cout << "Account " << i << ": " << endl << *((Account*)(accts[i])) << endl;
	accts[i]->deposit( 100000 );
	cout << "Account " << i << ": " << endl << *((Account*)(accts[i])) << endl;
  }
  
  for ( i = 0; i < accts.size(); i++ )
  {
	try 
	{
	  accts[i]->buy( "Biota", 100 );
	  accts[i]->buy( "Cisco", 200 );
	  accts[i]->buy( "Bubble.com", 50 );
	  accts[i]->buy( "Bubble.com", 15000 ); 
	  accts[i]->processInterest();
	}
	catch ( UnknownSymbol u )
	{
	  cout << "Unknown symbol: " << u.name << endl;
	}
	catch ( InsuffFunds f )
	{
	  cout << "Account doesn't have enough cash to spend $" << f.request << endl;
	}
  }
  
  for ( i = 0; i < accts.size(); i++ )
  {
	cout << "Account " << i << ": " << endl << *((Account*)(accts[i])) << endl;
  }
  
  for ( i = 0; i < accts.size(); i++ )
  {
	try 
	{
	  accts[i]->withdraw( 100 );
	  accts[i]->withdraw( 20000 );
	  accts[i]->withdraw( 1000000 );
	}
	catch ( InsuffFunds f )
	{
	  cout << "Account doesn't have enough cash to withdraw $" << f.request << endl;
	}
  }
  
  NASDAQ.setPrice( "MS", 12 );
  NASDAQ.setPrice( "Cisco", 120 );
  NASDAQ.setPrice( "Bubble.com", 323 );
  NASDAQ.setPrice( "Biota", 158 );
  
  for ( i = 0; i < accts.size(); i++ )
  {
	try 
	{
	  accts[i]->sell( "Biota", 100 );
	  accts[i]->sell( "Cisco", 100 );
	  cout << "Account " << i << ": " << endl << *((Account*)(accts[i])) << endl;
	  
	  accts[i]->sell( "Biota", 100 );  // error expected!
	  accts[i]->sell( "Cisco", 100 );
	  accts[i]->sell( "Bubble.com", 50 );
	  accts[i]->sell( "Bubble.com", 15000 );
	  accts[i]->processInterest();
	}
	catch ( InsuffShares s )
	{
	  cout << "Account doesn't have " << s.nShares << " shares of " << s.name << " to sell!" << endl;
	}
  }
  
  for ( i = 0; i < accts.size(); i++ )
  {
	cout << "Account " << i << ": " << endl << *((Account*)(accts[i])) << endl;
  }	
  
}